# Better Team Balance

Yet another autobalance mod. Except it's a bit smorter and comes with additional features. All with the overarching purpose of improving team balancing on a server, so that we might enjoy challenging and even matches more often. Relies on FSU for chat commands. Also you will want to disable FSUs built-in auto balance, as well as its team shuffle feature.

If you do not, this mod will now override those convars if a conflicting feature is enabled, in order to ensure proper functioning. This may not take during the first match after a server is started, however, so it is better to disable them using FSU's convars directly.

Get FSU here: [Fifty's Server Utilities](https://northstar.thunderstore.io/package/Fifty/Server_Utilities/)

### Changelog

#### 1.1.0

- New feature: Team shuffle between matches that will attempt to use stats from the previous game to create balanced teams
- New feature: The mod will now override FSU setting convars and disable a conflicting FSU feature, if the corresponing one is enabled in BTB
- Auto-balance now works immediately during the first 40 seconds of a match

#### 1.0.4

- Bugfix - the mod now runs again

#### 1.0.3

- Forced rebalance and chat suggestions can now both be enabled, with different activation thresholds
- Same as 1.0.2 but comes with sane defaults
- Note the changed convars in mod.json

### Features

#### Balanced Team Shuffle

- Based on score\*KD\*25% randomness
- Player ranking information is saved into a convar at the end of a match
- At the beginning of the next match, the rankings are then pulled and used to inform the shuffle
- Accounts for players leaving/joining between games, by waiting until the next match to actually shuffle the teams

#### Auto-Balance

- When one team has too many players, one of them is swapped over on death (like FSU)
- Before doing so, will wait a moment in case new players join
- Wait is disabled for the first 40 seconds of a match, in order to quickly level team imbalances due to leaving players
- Disabled for the last minute of a match, no victories ruined by a last second swap over to losing side

#### Mid-Match Team Rebalance

- Rebalance teams based on score*KD in relevant game modes, otherwise only KD
- Redistributes points earned by players to their respective new teams (in round based modes, simply equalizes them)
- Can trigger on vote, and/or on crossing a configurable score imbalance detection threshold
- By default, only a threshold for informing players via chat about the "!balance" command, is used
- To activate balancing automatically, set the relevant threshold using the correct convar (check mod.json)

#### AFK Kicking

- Set a playercount, below which afk players waiting for the server to fill up, wont be kicked
- UIDs set as admin in FSU are immune

Check mod.json for all convars and config optios.
